using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Diagnostics;
using System.Web;
using System.Web.Services;

using System.Web.Services.Protocols; //for SOAPHeader
using System.EnterpriseServices; //for Transactions (must add Assembly Reference as well)

namespace DotNetLaunch
{
	/// <summary>
	/// Summary description for Service1.
	/// </summary>
	public class DemoMain : System.Web.Services.WebService
	{
		public DemoMain()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();
		}

		#region Component Designer generated code
		
		//Required by the Web Services Designer 
		private IContainer components = null;
				
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion


		/// <summary>
		/// DEMO #1 (SERVER)
		/// This method shows how to use Session State (must use WebMethod attribute EnableSession)
		/// </summary>
		[WebMethod(EnableSession=true)]
		public string SessionDemo()
		{
			if (Application["AppHits"] == null)
				Application["AppHits"] = 1;
			else
				Application["AppHits"] = ((int)Application["AppHits"]) + 1;

			if (Session["MyHits"] == null)
				Session["MyHits"] = 1;
			else
				Session["MyHits"] = ((int)Session["MyHits"]) + 1;

			return DateTime.Now.ToString() + ", " +
					"App Hits: " + Application["AppHits"] + ", " +
					"My Hits: " + Session["MyHits"];
					
		}

		/// <summary>
		/// DEMO 2 (Custom SOAP Header, must be public + inherit from SoapHeader)
		/// </summary>
		public class AuthHeader : SoapHeader
		{
			public string UserName;
			public string Password;
		}

		/// <summary>
		/// DEMO 2 (Custom SOAP Header, must be public)
		/// </summary>
		public AuthHeader authHeader;

		/// <summary>
		/// DEMO 2 (Customer SOAP Header, SoapHeaader Attribute name must equal member name)
		/// </summary>
		[WebMethod]
		[SoapHeader("authHeader", Required=true, Direction=SoapHeaderDirection.InOut)]
		public bool AuthDemo()
		{
			if (authHeader.UserName == "Squirel" &&
				authHeader.Password == "Secret")
				return true;

			//for now, only Secret Squirel gets in
			return false;
		}

		/// <summary>
		/// DEMO 4 : Transaction (straight from the .NET Documentation)
		/// Note that the TransactionOption (Requires = RequiresNew).
		/// Note the lack of a try/catch (any exception automatically calls SetAbort).
		/// Note the lack of an explicit SetComplete (called upon return without any Exception raised).
		/// </summary>
		[WebMethod(TransactionOption=TransactionOption.RequiresNew)]
		public int DeleteAuthor(string lastName)  
		{
			String deleteCmdSQL = "DELETE FROM authors WHERE au_lname='" + lastName + "'" ;

			String exceptionCausingCmdSQL = "DELETE FROM NonExistingTable WHERE	au_lname='" + lastName + "'" ;

			SqlConnection sqlConn = new SqlConnection("user id=sa;database=pubs;server=(local)");

			SqlCommand deleteCmd = new SqlCommand(deleteCmdSQL,sqlConn);
			SqlCommand exceptionCausingCmd = new SqlCommand(exceptionCausingCmdSQL,sqlConn);

			// This command should execute properly.
			deleteCmd.Connection.Open();
			deleteCmd.ExecuteNonQuery();

			// This command results in an exception, so the first command is
			// automatically rolled back.  Since the XML Web service method is
			// participating in a transaction, and an exception occurs, ASP.NET
			// automatically aborts the transaction.  The deleteCmd that
			// executed properly is rolled back.

			//int cmdResult = exceptionCausingCmd.ExecuteNonQuery();

			sqlConn.Close();

			//return cmdResult;
			return 0;
		}

	}
}
