using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using DotNetLaunchWinFormClient.localhost;
using System.Net; //for Cookie Container
using System.Text; //for StringBuilder
using System.Xml;

namespace DotNetLaunchWinFormClient
{
	/// <summary>
	/// .NET Launch Demo WinForms Web Service Client
	/// </summary>
	public class frmMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnSession;
		private System.Windows.Forms.TextBox txtMsg;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button btnClearCookies;
		private System.Windows.Forms.Button btnSOAPHdr;
		private System.Windows.Forms.Button btnWindowsAuth;
		private System.Windows.Forms.Button btnTrans;

		//For ASP Session State, you must use cookies:
		private CookieContainer myCookies = new CookieContainer();

		public frmMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnSession = new System.Windows.Forms.Button();
			this.txtMsg = new System.Windows.Forms.TextBox();
			this.btnClearCookies = new System.Windows.Forms.Button();
			this.btnSOAPHdr = new System.Windows.Forms.Button();
			this.btnWindowsAuth = new System.Windows.Forms.Button();
			this.btnTrans = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// btnSession
			// 
			this.btnSession.Location = new System.Drawing.Point(8, 8);
			this.btnSession.Name = "btnSession";
			this.btnSession.TabIndex = 0;
			this.btnSession.Text = "Session";
			this.btnSession.Click += new System.EventHandler(this.btnSession_Click);
			// 
			// txtMsg
			// 
			this.txtMsg.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.txtMsg.Font = new System.Drawing.Font("Microsoft Sans Serif", 14.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtMsg.Location = new System.Drawing.Point(8, 88);
			this.txtMsg.Multiline = true;
			this.txtMsg.Name = "txtMsg";
			this.txtMsg.Size = new System.Drawing.Size(548, 176);
			this.txtMsg.TabIndex = 1;
			this.txtMsg.Text = "";
			// 
			// btnClearCookies
			// 
			this.btnClearCookies.Location = new System.Drawing.Point(96, 8);
			this.btnClearCookies.Name = "btnClearCookies";
			this.btnClearCookies.Size = new System.Drawing.Size(88, 23);
			this.btnClearCookies.TabIndex = 2;
			this.btnClearCookies.Text = "Clear Cookies";
			this.btnClearCookies.Click += new System.EventHandler(this.btnClearCookies_Click);
			// 
			// btnSOAPHdr
			// 
			this.btnSOAPHdr.Location = new System.Drawing.Point(200, 8);
			this.btnSOAPHdr.Name = "btnSOAPHdr";
			this.btnSOAPHdr.Size = new System.Drawing.Size(88, 23);
			this.btnSOAPHdr.TabIndex = 3;
			this.btnSOAPHdr.Text = "SOAP Header";
			this.btnSOAPHdr.Click += new System.EventHandler(this.btnSOAPHdr_Click);
			// 
			// btnWindowsAuth
			// 
			this.btnWindowsAuth.Location = new System.Drawing.Point(296, 8);
			this.btnWindowsAuth.Name = "btnWindowsAuth";
			this.btnWindowsAuth.Size = new System.Drawing.Size(88, 23);
			this.btnWindowsAuth.TabIndex = 4;
			this.btnWindowsAuth.Text = "Windows Auth";
			this.btnWindowsAuth.Click += new System.EventHandler(this.btnWindowsAuth_Click);
			// 
			// btnTrans
			// 
			this.btnTrans.Location = new System.Drawing.Point(400, 8);
			this.btnTrans.Name = "btnTrans";
			this.btnTrans.Size = new System.Drawing.Size(88, 23);
			this.btnTrans.TabIndex = 5;
			this.btnTrans.Text = "Transaction";
			this.btnTrans.Click += new System.EventHandler(this.btnTrans_Click);
			// 
			// frmMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(568, 277);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.btnTrans,
																		  this.btnWindowsAuth,
																		  this.btnSOAPHdr,
																		  this.btnClearCookies,
																		  this.txtMsg,
																		  this.btnSession});
			this.Name = "frmMain";
			this.Text = ".Net Launch Web Services Demo";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}

		/// <summary>
		/// DEMO #1a
		/// Must use CookieContainer to enable ASP.NET Session state to work
		/// </summary>
		private void btnSession_Click(object sender, System.EventArgs e)
		{
			DotNetLaunchWinFormClient.localhost.DemoMain m = new DemoMain();
			
			//** Must Use same Cookie Container on each call to persist state
			m.CookieContainer = myCookies;
			
			txtMsg.Text = m.SessionDemo();
		}

		/// <summary>
		/// DEMO #1b
		/// Demonstrates the relationship between the ClientCookieCollection & Session
		/// </summary>
		private void btnClearCookies_Click(object sender, System.EventArgs e)
		{
			myCookies = new CookieContainer();
			MessageBox.Show("This client's Cookies cleared.");
		}

		/// <summary>
		/// DEMO #2 - Custom SOAP Header
		/// The Header Value (AuthHeader) is in/out
		/// </summary>
		private void btnSOAPHdr_Click(object sender, System.EventArgs e)
		{
			DotNetLaunchWinFormClient.localhost.DemoMain m = new DemoMain();
			DotNetLaunchWinFormClient.localhost.AuthHeader ah = new AuthHeader();
		
			ah.UserName = "Squirel";
			ah.Password = System.DateTime.Now.Second % 2 == 0 ? "Secret" : "WrongPassword";
			m.AuthHeaderValue = ah;
			
			if (m.AuthDemo())
				MessageBox.Show("We're in.");
			else
				MessageBox.Show(
									new StringBuilder(m.AuthHeaderValue.UserName).
									Append("-").
									Append(m.AuthHeaderValue.Password).
									Append(" failed.")
									.ToString()
								);
		}

		/// <summary>
		/// DEMO #3 Windows Authentication (uses IIS File Security Tab on .asmx file, no Anonymous)
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void btnWindowsAuth_Click(object sender, System.EventArgs e)
		{
			localhost1.WindowsAuthDemo wad = new localhost1.WindowsAuthDemo();

			//*** Must Have this Line to Avoid 401 Access Denied Error ***
			wad.Credentials = System.Net.CredentialCache.DefaultCredentials;

			// *** Could also use a specific credential (INSTEAD of DefaultCredentials above):
			//System.Net.NetworkCredential cr = new System.Net.NetworkCredential("username","password","domain");
			//wad.Credentials = cr;

			//Get the DataSet from the Windows Authenticated Web Service
			DataSet ds = wad.HelloWorldDataSet();

			//Create a New form, add a DataGrid, bind & format it:
			Form f = new Form();
			f.Text = ds.Tables[0].Rows.Count.ToString() + " rows.";
			DataGrid dg = new DataGrid();
			dg.Dock=DockStyle.Fill;
			dg.DataSource = ds.Tables[0];
			f.Controls.Add(dg);
			f.Show();
		}

		/// <summary>
		/// DEMO #4 Transaction
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void btnTrans_Click(object sender, System.EventArgs e)
		{
			localhost.DemoMain dm = new localhost.DemoMain();
			
			this.Cursor=Cursors.AppStarting;
			dm.DeleteAuthor("foo");
			this.Cursor=Cursors.Arrow;
		}
	}
}
